# -*- coding: utf-8 -*-
"""
Created on Fri Aug 26 13:30:49 2022

@author: awa
"""

import socket
import time
from pathlib import Path

import numpy as np
from epics import caget, caput
from interface import AWAInterface


nshots = 25

tstamp = time.strftime("%Y%m%d-%H%M%S")
# rootname = 'tdcOn_250000_Jlab210_transparentMode'
# rootname = 'tdcOff_JlabOff_drift'
rootname = "bunchlength-128000"

print(rootname + "_" + tstamp)
filename = rootname + "_" + tstamp


screen = AWAInterface()

ict = 0
for i in range(nshots):
    caput("AWATrigCtrl:GetCh8.PROC", 1)
    while caget("AWATrigCtrl:GetCh8") > 0:
        caput("AWATrigCtrl:GetCh8.PROC", 1)
    ict_tmp = np.abs(caget("AWAICTMon:Ch1"))
    caput("AWATrigCtrl:SetCh8", 1)
    ict = ict + ict_tmp
    print(ict_tmp)
Charge = ict / nshots

print(Charge)

img, sdata, roi = screen.save_data(
    filename,
    target_charge=Charge,
    charge_deviation=0.3,  # within +/- 10% deviation
    n_samples=nshots,
    stat=True,
)  # Number of samples
