# -*- coding: utf-8 -*-
"""
Created on Tue Jul 20 19:46:18 2021

@author: awa
"""
import sys

sys.path.insert(0, "F:\\2022\\pyctrl-awa\\base\\")
import time

import matplotlib.pyplot as plt
import numpy as np
from epics import caget, caput
from interface import AWAInterface

phi = caget("AWALLRF:K5:SetPhaseRB")
power = caget("AWA:DAC0:Ch13")

# rootname = 'tdcPhiScan_fullscan_YAG14'
rootname = "tdcCal_Phi_" + str(phi) + "_LLRF_" + str(power) + "_"
N = 35
nshots = 5
phase_k5 = np.linspace(45, 445, N)  # np.linspace(0,400,N)
phase_k5_measured = caget("AWALLRF:K5:SetPhase")
# ---------------------------------------------

tstamp = time.strftime("%Y%m%d-%H%M%S")

screen = AWAInterface()

ict = 0
for i in range(nshots):
    caput("AWATrigCtrl:GetCh8.PROC", 1)
    while caget("AWATrigCtrl:GetCh8") > 0:
        caput("AWATrigCtrl:GetCh8.PROC", 1)
    ict_tmp = np.abs(caget("AWAVXI11ICT:Ch1"))
    caput("AWATrigCtrl:SetCh8", 1)
    ict = ict + ict_tmp
    print(ict_tmp)
Charge = ict / nshots

print("avg charge", Charge)

CentroidX = np.zeros((N))
CentroidY = np.zeros((N))
dCentroidX = np.zeros((N))
dCentroidY = np.zeros((N))
PhaseShifter = np.zeros((N))
print(rootname + "_" + tstamp)

power = caget("AWA:DAC0:Ch13")

filename = rootname + "_" + str(power) + "_" + tstamp
# filename=rootname+'_'+str("{0:03}".format(i))+'_'+str(power)+'_'+tstamp

for i in range(N):
    caput("AWALLRF:K5:SetPhase", phase_k5[i])
    time.sleep(3.5)
    #    PhaseShifter[i] = caget("TDC2O4PhSh:Pos")
    PhaseShifter[i] = caget("AWALLRF:K5:SetPhaseRB")
    time.sleep(0.5)
    print(PhaseShifter[i])
    tmpx = 0
    tmpy = 0
    tmpx2 = 0
    tmpy2 = 0

    for j in range(nshots):
        results = image_diagnostic.measure_beamsize(1, **inputs)
        tmpx = tmpx + results["Cx"]
        tmpy = tmpy + results["Cy"]
        tmpx2 = tmpx2 + results["Cx"] ** 2
        tmpx2 = tmpy2 + results["Cy"] ** 2

    CentroidX[i] = tmpx / nshots
    CentroidY[i] = tmpy / nshots
    dCentroidX[i] = tmpx2 / nshots - CentroidX[i]
    dCentroidY[i] = tmpy2 / nshots - CentroidY[i]

    time.sleep(0.5)


# plt.errorbar(PhaseShifter/1850,CentroidY,yerr=dCentroidY)
# c=np.polyfit(PhaseShifter/1850,CentroidY,1)
plt.errorbar(PhaseShifter, CentroidY, yerr=dCentroidY)
c = np.polyfit(PhaseShifter, CentroidY, 1)

print(c)

np.savez(filename, phase=PhaseShifter, ceny=CentroidY, dceny=dCentroidY)

print(filename)


# plt.scatter()

# plt.grid()
# plt.savefig(f'{filename}.png',dpi=100)
# plt.show()
