# -*- coding: utf-8 -*-
"""
Created on Fri Aug 26 16:19:45 2022

@author: awa
"""

# -*- coding: utf-8 -*-
"""
Created on Tue Jul 20 19:46:18 2021

@author: awa
"""
import sys

sys.path.insert(0, "F:\\2022\\pyctrl-awa\\base\\")
import time

import matplotlib.pyplot as plt
import numpy as np
from epics import caget, caput
from interface import AWAInterface
from ESSPSCtrl import *

rootname = "tdcPhiJlabscan"
N = 40
nshots = 3
step = 17000

count_transp = str(caget("TDC2O4PhSh:Pos"))
coil_value_transp = float(str(MeasureCurrent()).split("=")[1].split("Amps")[0])
calCount2Rad = 9.707059243572466e-06
# ---------------------------------------------
# make sure the coil PS is loaded and you did an Initialize()


rootname = rootname + "_TDC" + str(count_transp) + "_JLab" + str(coil_value_transp)

tstamp = time.strftime("%Y%m%d-%H%M%S")

screen = AWAInterface()

ict = 0
for i in range(nshots):
    caput("AWATrigCtrl:GetCh8.PROC", 1)
    while caget("AWATrigCtrl:GetCh8") > 0:
        caput("AWATrigCtrl:GetCh8.PROC", 1)
    ict_tmp = np.abs(caget("AWAICTMon:Ch1"))
    caput("AWATrigCtrl:SetCh8", 1)
    ict = ict + ict_tmp
    print(ict_tmp)
Charge = ict / nshots


CentroidX = np.zeros((N))
CentroidY = np.zeros((N))
dCentroidX = np.zeros((N))
dCentroidY = np.zeros((N))
PhaseShifter = np.zeros((N))
CoilValues = np.zeros((N))

print(rootname + "_" + tstamp)

for i in range(N):
    filename = rootname + "_" + str("{0:03}".format(i)) + "_" + tstamp
    caput("TDC2O4PhSh:MoveRel", step)
    time.sleep(3.5)
    PhaseShifter[i] = caget("TDC2O4PhSh:Pos")
    factor = np.cos(calCount2Rad * (PhaseShifter[i] - count_transp))
    if factor >= 0:
        CoilValues[i] = coil_value_transp * factor
        SetCurrent(CoilValues[i])
        print("--> coil", CoilValues[i])
        time.sleep(2)
        print(PhaseShifter[i])
        #    _, sdata, roi = screen.get_data(n_samples=nshots, stat=True)

        _, sdata, roi = screen.save_data(
            filename,
            target_charge=Charge,
            charge_deviation=0.3,  # within +/- 10% deviation
            n_samples=nshots,
            stat=True,
        )  # Number of samples

        CentroidX[i] = np.mean(sdata[:, 3])
        CentroidY[i] = np.mean(sdata[:, 4])
        dCentroidX[i] = np.std(sdata[:, 3])
        dCentroidY[i] = np.std(sdata[:, 4])
    if factor < 0:
        print("monopolar supply -- set to zero only")
    time.sleep(0.5)


fname = rootname + "_" + tstamp + "txt"

np.savez(
    filename,
    phase=PhaseShifter,
    ceny=CentroidY[i],
    dceny=dCentroidY[i],
    coil=CoilValues,
)


# plt.scatter()

# plt.grid()
# plt.savefig(f'{filename}.png',dpi=100)
# plt.show()
